Dart2.6正式版发布了,支持编译为三大系统的Native文件 [复制链接]

2019-11-11 10:24
aishare 阅读:322 评论:0 赞:0
Tag:  Dart Native文

近日Dart团队发布了Dart 又双叒叕 更新了。是的,你没听错。Dart团队在11月初正式发布了 Dart2.6 的正式版本。(估计好多读者内心波澜:求你们别更新了,我学不动了)。别担心,我在这里逐个帮大家分析一下Dart2.6这次更新有什么亮点,官方的都是英文,如果大家利用工具翻译的话,机器翻译的语言句子不通顺,不太容易理解,所以这时候 精通英语四级的我 就派上用场了。专门帮大家整理了一些核心知识点,写在这里分享给大家。作者写文章不容易,觉得好看的话,点一下文末的“在看”,支持一下吧,谢谢大家。

通过前面的文章介绍,想必大家对Dart也有所了解了,Dart针对不同系统平台提供了丰富的编译器:适用于Android和iOS的“Flutter”,用于Web开发的“Flutter Web”,适用于桌面端的“Flutter”(该功能处于实验中),使用AngularDart 进行Web开发等,这些都离不开Dart的编译器。


最近Dart团队推出了最新版本的Dart功能的更新,最大的亮点是:“dart2native”。它是现有编译器基础上的一个扩展,能够将Dart程序编译为包含预编译(AOT)机器码的self-contained的可执行程序。使用dart2native,您可以使用Dart 通过macOS,Windows或Linux上的命令行创建工具。此功能的演示图如下所示:

相关链接:

Dart支持的系统平台:

https://dart.dev/platforms

AngularDart介绍:

https://angulardart.dev/
1

DartNative和dart2native编译器

Dart支持将AOT(预编译)编译为本地机器代码已有多年,因此Dart Native是相当成熟的技术。但是过去,Dart仅通过Flutter在iOS和Android移动设备上发布了此功能。现在借助dart2native,扩展了native编译支持,以支持运行macOS,Windows和Linux的传统桌面操作系统。由于使用dart2native创建的可执行文件是独立的,因此它们可以在未安装Dart SDK的计算机上运行。并且由于它们是使用Dart的AOT编译器进行编译的,因此可执行文件仅在几毫秒内即可开始运行。与其他Dart编译器和运行时一样,当编译为native代码时,Dart中可以使用相同的一套核心库 core libraries。

如果你以前使用过dart2aot,那么从Dart2.6开始,你将使用dart2native,这个是dart2aot的超集,比dart2aot更完善。

2

Dart2.6下载和安装

Dart官网已经支持Dart2。6的文档,网址如下:

https://dart。dev/get-dart

首先我们找到下载地址,可以点击:

https://dart.dev/tools/sdk/archive

然后在 Stable channel 里面,选择你对应的系统(Windows、Linux、Mac),然后选择根据你电脑对应的系统架构进行下载对应的文件,比如:X64是64位,ia32是32位。下好之后,解压缩,选择一个英文的安装路径(不要是Flutter的安装路径,否则会出现错误),然后将安装路径添加到环境变量“path”里面,重启一下电脑,即可使用Dart命令行了。

【注意】:Dart SDK的安装和Flutter内置的Dart SDK是不一致的,不能共用。需要单独设置安装文件夹分别存放。输入dart –version,查看Dart版本号,输入where dart查看Dart安装路径。如下图所示:

使用dart2native编译命令行应用程序

dart2native可以用于构建和部署命令行程序。通常会使用诸如:dart:io(基本I/O)、package:http(网络操作)、package:args(参数解析)之类的库。

下面看一下dart2native将“ hello.dart”应用编译为可执行文件简单的示例代码:hello.dart源代码:

接下来:编译hello。dart为可执行文件:

编译过程如下图所示:

4dart2native对dart:ffi的增强及其兼容性

native应用程序通常需要从操作系统访问本地API功能。这些系统api通常在本地的基于C的库中存在,而Dart通过dart:ffi 支持与这些库的互交互性,这是Dart 2.5的预览版中推出的Dart与C交互的新功能。

Dart2.6对许多dart:ffi的API进行了重大更改,使我们的API易于使用,提供更多的类型安全性并提供对内存的便捷访问,dart2native编译器与dart:ffi兼容,因此您可以创建和编译使用它的本地的dart应用程序。

Dart的某位团队成员最近开始使用dart:ffi创建了一个用于控制台应用程序开发的dart_console库,它具有诸如获取窗口尺寸、读取和设置光标位置、管理颜色、读取键和控制序列等功能。使用dart的能力:ffi使dart成为一种非常强大的控制台应用程序语言。dart_console是Kilo文本编辑器的Dart版本实现。Kilo库使用C语言编写而成,大约有1000行代码。

dart_console库下载:

https://pub.dev/packages/dart_console

Kilo源码地址:

https://github.com/antirez/kilo

500行代码打造Dart控制台代码编辑器

使用dart:core核心库、dart:ffi 和 dart_console 库,我们可以创建非常有趣的控制台应用程序。dart_console库包括一个完整的 Kilo 演示,这是一个用大约500行Dart代码编写的控制台文本编辑器。使用新的dart2native编译器,我们可以轻松地打包它,最后得到一个7MB的self-contained代码编辑器。

下图是一个编译编辑器的演示,然后使用编译的编辑器编辑自己的源代码来修复错误:

6

基于dart2native的服务端架构性能大大提升

对于无服务器后端,服务快速启动至关重要。传统上,基于Dart的服务与我们的JIT(即时)编译器一起运行,但是基于JIT的执行在启动时会存在较高的延迟,因为需要对其进行编译和预热后才能开始执行代码。通过将服务的代码提前编译为native代码,您可以避免这种延迟并立即开始运行。此外,使用native代码,您可以创建具有较小磁盘占用空间且独立的Dart services,从而大大减小了运行Dart services的容器的大小。实验表明,使用dart2native编译器,能够将Docker镜像的大小减少91%,从使用JIT编译的220MB的代码减少至使用native编译的20MB的代码!

有关服务器端应用程序和软件包的更多详细信息,可以查看以下文档:

服务器端应用程:

https://dart.dev/tutorials/server/httpserver

软件包:

https://dart.dev/server/libraries#server-packages

7

暂时尚未解决的问题

Dart2。6暂时还有一些问题需要解决的,主要有以下几个:

Dart2.6暂不支持交叉编译

dart2native编译器仅支持为其运行的操作系统创建native代码。因此,如果要为macOS,Windows和Linux上这三个平台的程序创建可执行文件,则需要分别在各个平台运行该编译器。一种实现方法是使用能够同时支持三种操作系统的CI(连续集成)程序。

暂不支持签名

生成的可执行文件使用的格式与标准签名工具(例如codesign和signtool)不兼容。

暂不支持dart:mirrors和dart:developer这两个库

8

其他功能

Dart 2.6还包含令人兴奋的新语言功能“静态扩展方法”的预览版本,该功能允许像在特殊静态类型的表达式的实例成员一样,调用特别声明的静态函数。但是此功能仍然需要完善,官方也表示在下一个Dart SDK版本中将会正式启动这个功能。Dart类具有虚拟方法,比如就像thing.doStuff()这样的调用将调用thing表示的对象上的虚拟doStuff方法。向类添加方法的唯一方法是修改类。如果你是不是类的作者,你必须使用静态辅助函数(functions),而不是方法(methods),因此使用 doMyStuff(thing) 代替 thing.doMyStuff()。这对于单个功能是可以接受的。

更多关于“静态扩展方法”的资料可以查看官方的文档介绍:

https://github.com/dart-lang/language/issues/41


我来说两句
您需要登录后才可以评论 登录 | 立即注册
facelist
所有评论(0)
领先的中文移动开发者社区
18620764416
7*24全天服务
意见反馈:1294855032@qq.com

扫一扫关注我们

Powered by X3.2© 2001-2019 ( )

天津福彩快乐十分 秒速时时彩 贵州快3走势 湖北快3 浙江体彩网 河北快3代理 甘肃快3 上海体彩网 吉林福彩网 青海体彩网